#include "crack.h"

/*
 * This program is copyright (c) Alec Muffett 1991 except for certain
 * portions of code ("fdes-crypt.c") copyright (c) Robert Baldwin, Icarus
 * Sparry and Alec Muffett.  The author(s) disclaims all responsibility or
 * liability with respect to it's usage or its effect upon hardware or
 * computer systems.  This software is in the public domain and is freely
 * redisrtibutable PROVIDED that this copyright notice remains intact.
 */

/* These used to be enums. Oh well... non-portability rules OK */
#define ORDER_LCF	0
#define ORDER_LCFP	1
#define ORDER_MCF	2
#define ORDER_UCF	3
#define ORDER_LCB	4
#define ORDER_UCB	5
#define ORDER_MCB	6
#define NUMFILES	7

int
main (argc, argv)
    int argc;
    char *argv[];
{
    register int i;
    register char *ptr;
    int all_digits;
    int all_letters_upper;
    int all_letters_lower;
    char buffer[STRINGSIZE];

    FILE *fp;
    FILE *fps[NUMFILES];

    if (argc == 1)
    {
	printf ("Usage:\t%s dictsrc [dictsrc ...]\n", argv[0]);
	exit (1);
    }

    for (i = 0; i < NUMFILES; i++)
    {
        char scratch[255];

        sprintf(scratch, "dict.%c", i + 'a');
	if (!(fps[i] = fopen (scratch, "w")))
	{
	    perror (scratch);
	    exit (3);
	}
    }

    for (i = 1; argv[i]; i++)
    {
	if (!(fp = fopen (argv[i], "r")))
	{
	    perror (argv[i]);
	    exit (1);
	}

	printf ("dictpp: sourcing from file '%s'\n", argv[i]);

	while (fgets (buffer, STRINGSIZE, fp))
	{
	    Trim (buffer);
	    if (!*buffer || !buffer[1])	/* skip single letters */
	    {
		continue;
	    }

#ifndef SHORT_PASSWDS
	    if (strlen (buffer) < 5)
	    {
		continue;
	    }
#endif
	    all_letters_upper = 1;
	    all_letters_lower = 1;
	    all_digits = 1;

	    for (ptr = buffer; *ptr; ptr++)
	    {
	    	if (!isdigit(*ptr))
	    	{
	    	    all_digits = 0;
	    	}

		if (isupper (*ptr))
		{
		    all_letters_lower = 0;
		} else if (islower (*ptr))
		{
		    all_letters_upper = 0;
		}
	    }

	    if (all_digits)
	    {
		fprintf (fps[ORDER_LCF], "%.8s\n", buffer);
		continue;	/* hehehehehe */
	    }

	    if (!all_letters_upper)
	    {
		fprintf (fps[ORDER_UCF], "%.8s\n", Uppercase (buffer));
		fprintf (fps[ORDER_UCB], "%.8s\n", Uppercase (Reverse (buffer)));
	    } else
	    {
		fprintf (fps[ORDER_UCF], "%.8s\n", buffer);
		fprintf (fps[ORDER_UCB], "%.8s\n", Reverse (buffer));
	    }

	    if (!all_letters_lower)
	    {
		fprintf (fps[ORDER_LCF], "%.8s\n", Lowercase (buffer));
		fprintf (fps[ORDER_LCB], "%.8s\n", Lowercase (Reverse (buffer)));
	    } else
	    {
		fprintf (fps[ORDER_LCF], "%.8s\n", buffer);
		fprintf (fps[ORDER_LCB], "%.8s\n", Reverse (buffer));
		if (buffer[strlen(buffer) - 1] != 's')
		{
		    fprintf (fps[ORDER_LCFP], "%.8ss\n", buffer); 
		}
	    }

	    if (!all_letters_lower && !all_letters_upper)
	    {
		fprintf (fps[ORDER_MCF], "%.8s\n", buffer);
		fprintf (fps[ORDER_MCB], "%.8s\n", Reverse (buffer));
	    }
	}
	fclose (fp);
    }

    for (i = 0; i < NUMFILES; i++)
    {
	fclose (fps[i]);
    }
}
